/*

 * @Overview 작업자등록 페이지
 * @History 2024-03-20 / 최승연 / 최초작성
 * @ETC 거래처 리스트의 경우 입력 정보가 많아 별도의 팝업을 통해 정보를 입력
 */


class Tb_worker_class {
  constructor(container) {
    this.ajaxUrl = "./worker.ajax.php";
    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  getMainList(mode,...test) {
      const talert= window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
      let arr = test;
      let data = new Object();
      for(let i=0; i < arr.length; i++){
        let temp = [arr[i]]
        console.log();
        if(document.getElementById(arr[i]).type == "checkbox"){
            data[temp] = document.getElementById(temp).checked?"Y":"N";
        }else{
            data[temp] = document.getElementById(temp).value

        }
      }

      data.mode = mode
      ajax_json({
        url: this.ajaxUrl,
        data: data,
  
        success: (data) => {
          if(data.code) {
            this.tbList.setData(data.data);
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: (req, status, err) => {
          kuls_alert(err.message);
        },
        complete: () => {
          window.clearTimeout(talert);
          this.tbList.clearAlert();
        },
      });
  
      return true;
    }




  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   */
  setFilter() {
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I" },true);
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 삭제
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  cellClick(e, tgt) {
    // 체크박스 클릭
    switch (tgt.getField()) {
      case "JOB_FUNC":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        tgt.getElement().classList.add("tabulator-editable");
      break;
      case "OS_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        tgt.getElement().classList.add("tabulator-editable");
      break;
      case "RET_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        tgt.getElement().classList.add("tabulator-editable");
      break;
      case "DEPT_CD":
        popDept({
          DEPT_CD: "DEPT_CD",
          DEPT_NM: "DEPT_NM",
        },tgt.getRow());
      break;
      case "OS_BP_CD":
        popClient({
          OS_BP_CD: "BP_CD", OS_BP_NM:"BP_NM"
        },tgt.getRow());
      break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
    }
  }

  // 셀 수정
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }


 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
  putData() {
    let _this = this;

    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
      return false;
    }


    const blankObj = [];
    const reqData = [];

    this.tbList.getRows().forEach(row => {
      if(row.getData()['_STATUS_']){
        if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'RET_FLG').every(key => {

          const value = row._row.data[key];
          return (value === undefined || value === '');
        })){
          blankObj.push(row);
        }else{
          reqData.push(row.getData());
        }
      }
    })


    const postdata = reqData.length == 0 ? false : {
      'mode': 'putWorker',
      'reqdata': JSON.stringify(reqData),
    };

    if(!postdata){
      this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
      return false;
    };

    if(blankObj.length !== 0){
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: _this.ajaxUrl,
          data: postdata,
          success: function (data) {
            if (data.code) {
              kuls_success("저장되었습니다.");
              _this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else{
      ajax_json({
        url: _this.ajaxUrl,
        data: postdata,
        success: function (data) {
          if (data.code) {
            kuls_success("저장되었습니다.");
            _this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    
    }

  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter:"rownum", title: "NO", width: 50, },
      { field: "EMP_NO", title: "사번", width: 100,
        editor: tb_custom_editor.pkCode,
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
      },
      { field: "EMP_NM", title: "이름", width: 100, editor: "input", cssClass: "editable-cell",},
      { field: "EMP_SHORT_NM",  title: "약명", width: 120, editor: tb_custom_editor.upper,

      },
      { field: "DEPT_CD", title: "부서",   width: 100, cssClass: "editable-cell", },
      { field: "DEPT_NM", title: "부서명", width: 120 ,hozAlign:"left"},
      { field: "JOB_POS", title: "지위", width: 100,
        editor: "list",
        editorParams: { values: varsPosition },
        formatter: tb_common_funtions.formatterSelect,
        formatterParams: { values: varsPosition },
        cssClass:"user-list",
      }, //formatter 선택으로
      { field: "JOB_FUNC", title: "현장직", width: 100, cssClass: "tabulator-editable",
        formatter: tb_common_funtions.formatterToggleboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { field: "OS_FLG", title: "외주", width: 100, cssClass: "tabulator-editable", 
        formatter: tb_common_funtions.formatterToggleboxIcon, 
        formatterParams: { checkval: "Y" }, },
      { field: "OS_BP_CD", title: "외주처코드", width: 80, editor:tb_custom_editor.pop },
      { field: "OS_BP_NM", title: "외주처명", width: 180,hozAlign:"left" },
      { field: "RET_FLG",  title: "퇴사여부",  width: 100, cssClass: "tabulator-editable", formatter: tb_common_funtions.formatterToggleboxRedIcon, formatterParams: { checkval: "Y" }, },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      height:"100%",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      validationMode:"highlight",
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
    });


    // 데이터 불러오기
    this.tbList.on("tableBuilt", () => {
      this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    // cell 클릭 시에
    this.tbList.on("cellClick", (e, tgt) => {
      this.cellClick && this.cellClick(e, tgt);
    });
    // cell 수정 시에
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        this.getMainList && this.getMainList("getWorkerList", "EMP_NO","EMP_NM", "DEPT_CD", "DEPT_NM", "RET_FLG");
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData();
      });
    });
  }
}
const Tb_worker = new Tb_worker_class("#worker_table");
Tb_worker.init();
